#region String templates
S7_BROWSING_VALUE_ITEM_TEMPLATE = """<S7:S7ValueItem>
                  <S7:Description>{MemoryLocation}</S7:Description>
                  <S7:ItemId>
                    <S7:Access>ReadAndWrite</S7:Access>
                    <S7:BitIndex>{BitIndex}</S7:BitIndex>
                    <S7:ByteIndex>{ByteIndex}</S7:ByteIndex>
                    <S7:DataArea>{DataArea}</S7:DataArea>
                    <S7:DataType>{DataType}</S7:DataType>
                    <S7:SymbolName>{SymbolName}</S7:SymbolName>
                    <S7:WordLength>{WordLength}</S7:WordLength>
                  </S7:ItemId>
                  <S7:ServerDataType>{ServerDataType}</S7:ServerDataType>
                </S7:S7ValueItem>"""

S7_CONNECTION_ITEM_TEMPLATE = """<Array:anyType i:type="VariableGroupItem">
                <DisplayName i:nil="true" />
                <ServerItem i:type="S7:S7VariableID">
                  <S7:Access>{Access}</S7:Access>
                  <S7:BitIndex>{BitIndex}</S7:BitIndex>
                  <S7:ByteIndex>{ByteIndex}</S7:ByteIndex>
                  <S7:DataArea>{DataArea}</S7:DataArea>
                  <S7:DataType>{DataType}</S7:DataType>
                  <S7:SymbolName>{SymbolName}</S7:SymbolName>
                  <S7:WordLength>{WordLength}</S7:WordLength>
                </ServerItem>
                {VariableTemplate}
              </Array:anyType>"""

#ADS connection pair template for properties
XTS_base = """ <Array:anyType i:type="VariableGroupItem">
                  <DisplayName i:nil="true" />
                  <ServerItem i:type="System:string">{ServerVariableName}</ServerItem>
                  <SimulationVariable>
                    <Component>{ComponentName}</Component>
                    <Behaviour i:nil="true" />
                    <Property>{PropertyName}</Property>
                  </SimulationVariable>
                </Array:anyType>"""

#ADS connection pair template for servo dof
XPlanar_base = """<Array:anyType i:type="VariableGroupItem">
                  <DisplayName i:nil="true" />
                  <ServerItem i:type="System:string">{ServerVariableName}.{dof}</ServerItem>
                  <SimulationVariable i:type="SimulationDofVariable">
                    <Component>{ComponentName}</Component>
                    <Behaviour>{ServoControllerName}</Behaviour>
                    <Property>VALUE</Property>
                    <DofObject>{DOF}</DofObject>
                  </SimulationVariable>
                </Array:anyType>"""


ADS_SERVER_TEMPLATE = """<Array:anyType i:type="Server">
          <ConnectionSettings i:type="ADS:ServerConnectionSettings">
            <ADS:AdsPort>{PORT_HERE}</ADS:AdsPort>
            {ADDRESS_TEMPLATE_HERE}
          </ConnectionSettings>
          <DisplayName>{SERVER_NAME_HERE}</DisplayName>
          <ExtraSettings i:nil="true" />
          <ResetWithSimulation>false</ResetWithSimulation>
          <StartWithSimulation>false</StartWithSimulation>
          <StopWithSimulation>false</StopWithSimulation>
          <VariableGroups>
            {VARIABLE_GROUPS_HERE}
          </VariableGroups>
        </Array:anyType>"""

AMS_NET_ID_NILL = """<ADS:AmsNetId i:nil="true" />"""
AMS_NET_ID_ADDRESS = """<ADS:AmsNetId>{ADDRESS_HERE}</ADS:AmsNetId>"""


#Direction = SimulationToServer / ServerToSimulation
#UpdateMethod = Cyclic / 
ADS_VARIABLE_GROUP_TEMPLATE = """<Array:anyType i:type="VariableGroup">
              <AssumeExclusiveWriteToSimVariables>true</AssumeExclusiveWriteToSimVariables>
              <CyclicUpdateRate>PT0.05S</CyclicUpdateRate>
              <DataFlowDirection>{DIRECTION_HERE}</DataFlowDirection>
              <DelayErrorThreshold>PT5S</DelayErrorThreshold>
              <DelayWarningThreshold>PT0.2S</DelayWarningThreshold>
              <DisplayName>{GROUP_NAME_HERE}</DisplayName>
              <Enabled>true</Enabled>
              <ExtraSettings i:nil="true" />
              <UpdateMethod>{UPDATE_METHOD_HERE}</UpdateMethod>
              <Items>
              {VARIABLE_ITEMS_HERE}
              </Items>
            </Array:anyType>"""


OPC_UA_SERVER_ITEM_TEMPLATE = """<Array:anyType i:type="VariableGroupItem">
                  <DisplayName i:nil="true" />
                  <ServerItem i:type="OpcUA:ValueItemID">
                    <OpcUA:NodeId>ns=4;s=MAIN.sines</OpcUA:NodeId>
                    <OpcUA:arrayIndices>
                      <Array:unsignedInt>18</Array:unsignedInt>
                    </OpcUA:arrayIndices>
                  </ServerItem>
                  <SimulationVariable i:type="SimulationDofVariable">
                    <Component>2-Axis Servo Positioner #47</Component>
                    <Behaviour>Servo Controller</Behaviour>
                    <Property>J1</Property>
                    <DofObject>J1</DofObject>
                  </SimulationVariable>
                </Array:anyType>"""

#
STANDARD_VARIABLE_TEMPLATE = """ <Array:anyType i:type="VariableGroupItem">
                  <DisplayName i:nil="true" />
                  <ServerItem i:type="System:string">{ServerVariableName}</ServerItem>
                  <SimulationVariable>
                    <Component>{ComponentName}</Component>
                    {BehaviourTemplate}
                    {PropertyTemplate}
                </SimulationVariable>
                </Array:anyType>"""

DOF_VARIABLE_TEMPLATE = """<Array:anyType i:type="VariableGroupItem">
                  <DisplayName i:nil="true" />
                  <ServerItem i:type="System:string">{ServerVariableName}</ServerItem>
                  <SimulationVariable i:type="SimulationDofVariable">
                    <Component>{ComponentName}</Component>
                    {BehaviourTemplate}
                    <Property>{PropertyName}</Property>
                    <DofObject>{PropertyName}</DofObject>
                </SimulationVariable>
                </Array:anyType>"""


SIGNAL_MAP_VARIABLE_TEMPLATE = """<Array:anyType i:type="VariableGroupItem">
                  <DisplayName i:nil="true" />
                  <ServerItem i:type="System:string">{ServerVariableName}</ServerItem>
                  <SimulationVariable i:type="SimulationSignalMapPortVariable">
                    <Component>{ComponentName}</Component>
                    {BehaviourTemplate}
                    {PropertyTemplate}
                    <PortIndex>{PortNumber}</PortIndex>
                  </SimulationVariable>
                </Array:anyType>"""


#Empty proeprty name
EMPTY_PROPERTY_TEMPLATE = '<Property i:nil="true" />'
PROPERTY_NAME_TEMPLATE = '<Property>{PropertyName}</Property>'
#
EMPTY_BEHAVIOUR_TEMPLATE = '<Behaviour i:nil="true" />'
BEHAVIOUR_NAME_TEMPLATE = '<Behaviour>{BehaviourName}</Behaviour>'

NIL_TEMPLATE = 'i:nil="true"' #Used if behavior or property is empty 
ACCESS_OPTIONS = ["ReadAndWrite", "Read"] #RW for sim to server, R for server to sim
DATA_AREAS = ["Input", "Output", "Memory"]
DATA_TYPES = ["BOOL", "BYTE", "WORD", "DWORD", "SINT", "USINT", "INT", "UINT", "DINT", "UDINT", "REAL", "Unknown"] #Unknown is set for user defined data types
WORD_LENGTHS = {"BOOL" : "Bit", "BYTE" : "Byte", "Word" : "Word", "DWORD" : "DWord", "REAL" : "DWord", "SINT" : "Byte", "USINT" : "Byte", "INT" : "Word", "UINT" : "Word", "DINT" : "DWord", "UDINT" : "DWord"} #
MEMORY_AREA_SHORT = ["I", "Q", "M"] #Input, Output, Memory. For data flow direction, I goes to PLC, Q  and M come from PLC to simulation
DATA_TYPE_SHORT = ["", "B", "W", "D"] #Empty for Bool, B for Byte, W for Word, D for DWord
DATA_AREA_DICT = {MEMORY_AREA_SHORT[i]: DATA_AREAS[i] for i in range(len(MEMORY_AREA_SHORT))}

#endregion